<!--//
////////////////////////////////////////////////////////////////////////////////
//
//  Copyright  2007 addgadget.com  All rights reserved.
//
//  http://addgadget.com/
//
////////////////////////////////////////////////////////////////////////////////
//-->
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = onSettingsClosed;

var Speedfan = GetLibrary();
// add by tommy, 20090210 begin
var objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!//./root/cimv2");
// add by tommy, 20090210 end

var coreCount = System.Machine.CPUs.count;

var tmp0Index = 1;
var tmp1Index = 3;
var tmp2Index = 4;
var tmp3Index = 5;
var tmp4Index = 6;

var totalUsage = 0;
var core1Usage = 0;
var core2Usage = 0;
var core3Usage = 0;
var core4Usage = 0;
var core5Usage = 0;
var core6Usage = 0;
var core7Usage = 0;
var core8Usage = 0;

var core1Hist = new Array();
var core2Hist = new Array();
var core3Hist = new Array();
var core4Hist = new Array();
var core5Hist = new Array();

var maxHist = 110;
var timeout;
var drawstyle=0;

function onLoad()
{
    initHist();
    loadSettings();
    onTimer();
    setInterval("onTimer()",1000);
}

function onUnload()
{
}

function onSettingsClosed()
{
    loadSettings();
}

function onTimer()
{
    refreshdisplay();
    updateHist();
    updateGraph();
}

function updateHist()
{
    for (var j=0; j<coreCount; j++)
	{
		if (j == 0)
		  core1Usage = parseInt(System.Machine.CPUs.item(j).usagePercentage);

		if (j == 1)
		  core2Usage = parseInt(System.Machine.CPUs.item(j).usagePercentage);

		if (j == 2)
		  core3Usage = parseInt(System.Machine.CPUs.item(j).usagePercentage);

		if (j == 3)
		  core4Usage = parseInt(System.Machine.CPUs.item(j).usagePercentage);

		if (j == 0)
		  core5Usage = parseInt(100 - Math.round(System.Machine.availableMemory / System.Machine.totalMemory * 100));

		if (j == 0)
		  core6Usage = parseInt(System.Machine.totalMemory);

		if (j == 0)
		  core7Usage = parseInt(System.Machine.availableMemory);

		if (j == 0)
		  core8Usage = parseInt(Math.round(System.Machine.totalMemory - System.Machine.availableMemory));

	}

    if (core1Usage <= 0) core1Usage = 0;
    if (core2Usage <= 0) core2Usage = 0;
    if (core3Usage <= 0) core3Usage = 0;
    if (core4Usage <= 0) core4Usage = 0;
    if (core5Usage <= 0) core5Usage = 0;
    if (core6Usage <= 0) core6Usage = 0;
    if (core7Usage <= 0) core7Usage = 0;
    if (core8Usage <= 0) core8Usage = 0;

    totalUsage = Math.round( ( parseInt(core1Usage) + parseInt(core2Usage) + parseInt(core3Usage) + parseInt(core4Usage) ) / coreCount );

	if (core1Hist.push(core1Usage) > maxHist)
		core1Hist.shift();

	if (core2Hist.push(core2Usage) > maxHist)
		core2Hist.shift();

	if (core3Hist.push(core3Usage) > maxHist)
		core3Hist.shift();

	if (core4Hist.push(core4Usage) > maxHist)
		core4Hist.shift();

	if (core5Hist.push(core5Usage) > maxHist)
		core5Hist.shift();
}

function refreshdisplay()
{
    try
    {
        Speedfan.Refresh();
        var t0 = parseInt(Speedfan.GetTemperature(tmp0Index));
        var t1 = parseInt(Speedfan.GetTemperature(tmp1Index));
        var t2 = parseInt(Speedfan.GetTemperature(tmp2Index));
        var t3 = parseInt(Speedfan.GetTemperature(tmp3Index));
        var t4 = parseInt(Speedfan.GetTemperature(tmp4Index));
    } catch (ex) {}

    // add by tommy, 20090210 begin
    try
    {
        var osItems = objWMIService.ExecQuery("SELECT LastBootUpTime FROM Win32_OperatingSystem");
        var osEnum = new Enumerator(osItems);
        var boottemp = "";
        for (; !osEnum.atEnd(); osEnum.moveNext())
        var osItem = osEnum.item();
        var boottemp = osItem.LastBootUpTime;

        var year = boottemp.substr(0,4);
        var month = boottemp.substr(4,2);
        month = month - 1;
        var day = boottemp.substr(6,2);
        var hour = boottemp.substr(8,2);
        var min = boottemp.substr(10,2);
        var sec = boottemp.substr(12,2);

        var osBootTime = new Date(year,month,day,hour,min,sec);
        var currentTime = new Date();

        var seconds = (currentTime - osBootTime) / 1000;
        var days = Math.floor(seconds / 60 / 60 / 24);
        seconds = seconds - (days*24*60*60);
        var hours = Math.floor(seconds / 60 / 60);
        seconds = seconds - (hours*60*60);
        var minutes = Math.floor(seconds / 60);
        seconds = seconds - (minutes*60);
        seconds = Math.floor(seconds);

        if (days < 10) { days = "0" + days; }
        if (hours < 10) { hours = "0" + hours; }
        if (minutes < 10) { minutes = "0" + minutes; }
        if (seconds < 10) { seconds = "0" + seconds; }

        var uptimestr =  days + "d " + hours + "h " + minutes + "m " + seconds + "s";

        upTime.innerText = uptimestr;
    } catch (ex)
    {
        upTime.innerText = "NONE DETECTED";
    }
    // add by tommy, 20090210 end

    tmpTotal.innerText = (t0 == 0) ? "CPU Usage" : "CPU [ " + t0 + "C" + " ] ";
    usgTotal.innerText = totalUsage + "%";

    tmpCore1.innerText = (t1 == 0) ? "Core 1" : "1 [ " + t1 + "C" + " ] ";
    usgCore1.innerText = core1Usage+"%";

    tmpCore2.innerText = (t2 == 0) ? "Core 2" : "2 [ " + t2 + "C" + " ] ";
    usgCore2.innerText = core2Usage+"%";

    tmpCore3.innerText = (t3 == 0) ? "Core 3" : "3 [ " + t3 + "C" + " ] ";
    usgCore3.innerText = core3Usage+"%";

    tmpCore4.innerText = (t4 == 0) ? "Core 4" : "4 [ " + t4 + "C" + " ] ";
    usgCore4.innerText = core4Usage+"%";

    usgCore5.innerText = core5Usage+"%";

    usgCore6.innerText = core6Usage+"MB";

    usgCore7.innerText = core7Usage+"MB";

    usgCore8.innerText = core8Usage+"MB";
    try
    {
        bar1.style.width = parseInt( 0.5 * core1Usage );
        bar2.style.width = parseInt( 0.5 * core2Usage );
        bar3.style.width = parseInt( 0.5 * core3Usage );
        bar4.style.width = parseInt( 0.5 * core4Usage );
        bar5.style.width = parseInt( 0.5 * core5Usage );
    } catch (ex){}
}


function initHist()
{
    for (var i=0; i<maxHist; i++)
	{
	    core1Hist[i]=0;
	    core2Hist[i]=0;
	    core3Hist[i]=0;
	    core4Hist[i]=0;
	    core5Hist[i]=0;
	}
}

function updateGraph()
{
    var c1path = "m 0,100 ";
    var c2path = "m 0,100 ";
    var c3path = "m 0,100 ";
    var c4path = "m 0,100 ";
    var c5path = "m 0,100 ";
	var c1 = 0;
	var c2 = 0;
	var c3 = 0;
	var c4 = 0;
	var c5 = 0;
	var param="";

	for (var i=0; i<maxHist; i++)
	{

		c1 = parseInt(core1Hist[i]);
		c2 = parseInt(core2Hist[i]);
		c3 = parseInt(core3Hist[i]);
		c4 = parseInt(core4Hist[i]);
		c5 = parseInt(core5Hist[i]);

		if (drawstyle==1)
		{
		    param =  (c1 == 0) ? "m" : "l";
    	    c1path += " m " + parseInt(i+1) + ",100 " + param + " " + parseInt(i+1) + "," +parseInt(100-(c1)) + "";

    	    param =  (c2 == 0) ? "m" : "l";
      		c2path += " m " + parseInt(i+1) + ",100 " + param + " " + parseInt(i+1) + "," +parseInt(100-(c2)) + "";

      		param =  (c3 == 0) ? "m" : "l";
      		c3path += " m " + parseInt(i+1) + ",100 " + param + " " + parseInt(i+1) + "," +parseInt(100-(c3)) + "";

      		param =  (c4 == 0) ? "m" : "l";
      		c4path += " m " + parseInt(i+1) + ",100 " + param + " " + parseInt(i+1) + "," +parseInt(100-(c4)) + "";

      		param =  (c5 == 0) ? "m" : "l";
      		c5path += " m " + parseInt(i+1) + ",100 " + param + " " + parseInt(i+1) + "," +parseInt(100-(c5)) + "";
    	}
    	else
    	{
		    c1path += " l " + parseInt(i+1) + "," +parseInt(100-(c1));
		    c2path += " l " + parseInt(i+1) + "," +parseInt(100-(c2));
		    c3path += " l " + parseInt(i+1) + "," +parseInt(100-(c3));
		    c4path += " l " + parseInt(i+1) + "," +parseInt(100-(c4));
		    c5path += " l " + parseInt(i+1) + "," +parseInt(100-(c5));
		}

  	}
	c1path = c1path + " e";
	c2path = c2path + " e";
	c3path = c3path + " e";
	c4path = c4path + " e";
	c5path = c5path + " e";

	core1graph.path = c1path;
	core2graph.path = c2path;
	core3graph.path = c3path;
	core4graph.path = c4path;
	core5graph.path = c5path;
}

function loadSettings()
{
    drawstyle = System.Gadget.Settings.read("drawstyle");

    var b = System.Gadget.Settings.readString("background");
	if ( b != "") back = b; else back = "black";

	var ti;
	var valueCount = 5;
	debugLog("loadSettingsMain");
    for (var s = 0;s < valueCount; s++)
    {
        debugLog("loadSettingsMain:tmp"+s+" ->"+ System.Gadget.Settings.readString("tmp"+s+"index"));
        ti = System.Gadget.Settings.readString("tmp"+s+"index");
        if (ti != "")
        {
            switch (s)
            {
                case 0: tmp0Index = parseInt(ti);
                case 1: tmp1Index = parseInt(ti);
                case 2: tmp2Index = parseInt(ti);
                case 3: tmp3Index = parseInt(ti);
                case 4: tmp4Index = parseInt(ti);
            }
        }

    }
	toggleDualCoreMode();
    startGlobalBackground(ChangeBackground);
}

function ChangeBackground(BackgroundName)
{
    back = BackgroundName;
    System.Gadget.Settings.write("background", BackgroundName);
    toggleDualCoreMode();
}


function toggleDualCoreMode()
{
    var btop = 97;
    var bheight = 30;

    if (coreCount >= 4)
    {
        // add by tommy, 20090210 begin
        // document.body.style.height = 135;
	    // background.style.height = 135;
        document.body.style.height = 145;
	    background.style.height = 145;
        // add by tommy, 20090210 end
	    background.src = back + "_back.png";
	    tmpCore3.style.visibility = "visible";
	    tmpCore4.style.visibility = "visible";
	    usgCore3.style.visibility = "visible";
	    usgCore4.style.visibility = "visible";
	    bar3.style.visibility = "visible";
	    bar4.style.visibility = "visible";
	    back3.style.visibility = "visible";
	    back4.style.visibility = "visible";
    }
    else
    {
        // add by tommy, 20090210 begin
        // document.body.style.height = 113;
	    // background.style.height = 113;
        document.body.style.height = 123;
	    background.style.height = 123;
        // add by tommy, 20090210 end
	    background.src = back + "_back_b.png";
        // add by tommy, 20090210 begin
	    // btop = 75;
	    btop = 85;
        upTime.style.top = 71;
        // add by tommy, 20090210 end
	    bheight = 30;
	    tmpCore3.style.visibility = "hidden";
	    tmpCore4.style.visibility = "hidden";
	    usgCore3.style.visibility = "hidden";
	    usgCore4.style.visibility = "hidden";
	    bar3.style.visibility = "hidden";
	    bar4.style.visibility = "hidden";
	    back3.style.visibility = "hidden";
	    back4.style.visibility = "hidden";

    }

    linesx.style.top = btop;
    linesy.style.top = btop;
    core5graph.style.top = btop;
    core4graph.style.top = btop;
    core3graph.style.top = btop;
    core2graph.style.top = btop;
    core1graph.style.top = btop;
    border.style.top = btop;


    linesx.style.height = bheight;
    linesy.style.height = bheight;
    core5graph.style.height = bheight;
    core4graph.style.height = bheight;
    core3graph.style.height = bheight;
    core2graph.style.height = bheight;
    core1graph.style.height = bheight;
    border.style.height = bheight;

}

function runTaskManager()
{
    System.Shell.execute("taskmgr.exe");
}
